#include <bits/stdc++.h>

using namespace std;

int main()
{
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,q;
    cin >> n >> q;
    string s;
    cin >> s;
    string t = "";
    for(int i = 0; i < n; i++)
    {
        t += '?';
    }
    if(s == t)
    {
        vector<int> v(0);
        for(int i = 0; i < q; i++)
        {
            int a,b;
            cin >> a >> b;
            int duzina = b-a+1;
            if(duzina == 1){
                cout << 0 << endl;
            }
            else if(duzina == 2){
                cout << 1 << endl;
            }
            else if(duzina == 3){
                cout << 2 << endl;
            }
            else if(duzina == 4){
                cout << 4 << endl;
            }
            else if(duzina == 5){
                cout << 6 << endl;
            }
            else if(duzina == 6){
                cout << 9 << endl;
            }
            else if(duzina == 7){
                cout << 12 << endl;
            }
            else if(duzina == 8){
                cout << 16 << endl;
            }
            else if(duzina == 9){
                cout << 20 << endl;
            }
            else if(duzina == 10){
                cout << 25 << endl;
            }
            else{
                if(duzina%2==0){
                    cout << pow((duzina/2),2) << endl;
                }
                else{
                    cout << (duzina/2)*(duzina/2 + 1) << endl;
                }
            }
        }
    }
}